#include "adcdump.h"
#include "scopeadc.h"
#include "cmdhandle.h"
#include "fastusart.h"
#include <util/delay.h>

// Port number to dump
char DumpPortNumber;

#define TEST_USART_INPUT {if (USART_IS_RX_BYTE_AVAILABLE) {volatile char c = USART_READ_BYTE;cmd_handle_char(c);};}

// This is command code 2
void DecimalTextDump_8bit_AllChannels()
{

	// Prepare the ADC thing
	AdcLeftAdjustResult();
	ENABLE_ADC;

	while(ScopeOutputMode == 2)
	{
		//SendOutString(MCUID);	SendOutString("\n\r");
		TEST_USART_INPUT;
		for (int i=0;i<AvailableAdcCount;i++)
		{
			// 5Bit MUX? 6Bit MUX?
			#ifdef MUX5
				ADMUX = (ADMUX & 0b00011111) | (AdcMuxMask[i] & 0b00011111);
				if (bit_is_set(AdcMuxMask[i], 5))
					ADCSRB |= (1 << MUX5);
				else
					ADCSRB &= ~(1 << MUX5);
			#else
				ADMUX = (ADMUX & 0b00011111) | AdcMuxMask[i];
			#endif
			// Start the ADC conversion
			START_ADC;
			// Is conversion done?
			while (IS_ADC_CONVERSION_GOING) TEST_USART_INPUT;
			//_delay_ms(1);
			// Print the value!
			FastPrintDecimalNumber(ADCH);
			if (i == (AvailableAdcCount-1))
				SendOutString("\n\r");
			else
				SendOutString(" ");
		}		
	}

	DISABLE_ADC;
}

// This is command code 3
void DecimalTextDump_10bit_AllChannels()
{
}

// This is command code 4
void DecimalTextDump_8bit_OneChannel()
{
}

// This is command code 5
void DecimalTextDump_10bit_OneChannel()
{
}

// This is command code 6
void BinaryDump_8bit_OneChannel()
{
}
