//*************************************************************************************
//
//  SoR Scope - software to provide Oscilloscope-like with cheap Microcontrollers
//  and free PC software
//
//  Copyright (C) 2009,	Cosmin Prund
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//*************************************************************************************

#ifdef __PREPCONST__
#ifndef __CUSTOMISE__
#define __CUSTOMISE__

// Name your MCU whatever you want to name your MCU!
#define MCUID "Grate Axon 2009"

// Select the USART you want to use. If your MCU only offeres one USART this will be ignored
#define USEUSART 1

// Define your MCU speed
#define F_CPU 16000000UL

#endif
#endif

#ifdef __PREPCONST_ADC_PINS_
// Here you get to configure your ADC pin: That is, let the SoR Scope know what
// pins are available (depeding on hardware board design some pins might not be available).
// You also get the chance to name your pins something else! (maybe your hardware
// board design only exposes two of the ADC pins and you want them named "FRONT" and "BACK")
//
// In order to properly configure this you'll need to take a look at the datasheet for your
// Atmel Atmega MCU. Specifically you'll need to figure out the name of the "digital
// direction pin".
//
// ******************************************************************
ConfigADCPin("ADC0", ADC0D, &DIDR0, 0b000000);
ConfigADCPin("ADC1", ADC1D, &DIDR0, 0b000001);
ConfigADCPin("ADC2", ADC2D, &DIDR0, 0b000010);
ConfigADCPin("ADC3", ADC3D, &DIDR0, 0b000010);
ConfigADCPin("ADC4", ADC4D, &DIDR0, 0b000011);
ConfigADCPin("ADC5", ADC5D, &DIDR0, 0b000100);
ConfigADCPin("ADC6", ADC6D, &DIDR0, 0b000101);
ConfigADCPin("ADC7", ADC7D, &DIDR0, 0b000111);

ConfigADCPin("ADC8", ADC8D, &DIDR2, 0b100000);
ConfigADCPin("ADC9", ADC9D, &DIDR2, 0b100001);
ConfigADCPin("ADC10", ADC10D, &DIDR2, 0b100010);
ConfigADCPin("ADC11", ADC11D, &DIDR2, 0b100011);
ConfigADCPin("ADC12", ADC12D, &DIDR2, 0b100100);
ConfigADCPin("ADC13", ADC13D, &DIDR2, 0b100101);
ConfigADCPin("ADC14", ADC14D, &DIDR2, 0b100110);
ConfigADCPin("ADC15", ADC15D, &DIDR2, 0b100111);
// ******************************************************************
#endif
