//*************************************************************************************
//
//  SoR Scope - software to provide Oscilloscope-like with cheap Microcontrollers
//  and free PC software
//
//  Copyright (C) 2009,	Cosmin Prund
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//*************************************************************************************

#include "prepconst.h"
#include "fastusart.h"

// Send out string
void SendOutString(char * str)
{
	for(int i=0;str[i];i++)	{
		while (USART_DATA_REGISTER_NOT_EMPTY) ;
		USART_SEND_BYTE(str[i]);
	}
}


// The number has to be from 0 to 1024
void FastPrintDecimalNumber(int Number)
{

	// First digit (thousands) is 0 or 1
	while (USART_DATA_REGISTER_NOT_EMPTY) ;
	char PrintZero;
	if (Number >= 1000)
		{
			USART_SEND_BYTE('1');
			PrintZero = 1;
			Number = Number - 1000;
		}
	else
		PrintZero = 0;

	// Hundreeds digit; My number's from 0 to 999
	while (USART_DATA_REGISTER_NOT_EMPTY) ;
	if (Number >= 500)
		{
			// Number's from 500 to 999
			if (Number >= 700)
				{
					// Number is from 700 to 999
					if (Number >= 800)
						{
							// Number from 800 to 999
							if (Number >= 900)
								{
									// Number's from 900 to 999
									// I've got the digit!
									USART_SEND_BYTE('9');
									PrintZero = 1;
									Number = Number - 900;													
								}
							else
								{
									// Number's from 800 to 899
									// I've got the digit!
									USART_SEND_BYTE('8');
									PrintZero = 1;
									Number = Number - 800;													
								}
						}
					else
						{
							// Number is from 700 to 799
							// I've got the digit!
							USART_SEND_BYTE('7');
							PrintZero = 1;
							Number = Number - 700;													
						}
				}
			else
				{
					// Number is from 500 to 699
					if (Number >= 600)
						{
							// Number is from 600 to 699
							USART_SEND_BYTE('6');
							PrintZero = 1;
							Number = Number - 600;													
						}
					else
						{
							// Number is from 500 to 599
							USART_SEND_BYTE('5');
							PrintZero = 1;
							Number = Number - 500;													
						}
				};
		}
	else
		{
			// Number's from 0 to 499
			if (Number >= 200)
				{
					// Number is from 200 to 499
					if (Number >= 300)
						{
							// Number is from 300 to 499
							if (Number >= 400)
								{
									// Number from 400 to 499
									USART_SEND_BYTE('4');
									PrintZero = 1;
									Number = Number - 400;
								}
							else
								{
									// Number from 300 to 399
									USART_SEND_BYTE('3');
									PrintZero = 1;
									Number = Number - 300;
								}
						}
					else
						{
							// Number is from 200 to 299
							USART_SEND_BYTE('2');
							PrintZero = 1;
							Number = Number - 200;													
						}
				}
			else
				{
					// Number is from 0 to 199
					if (Number >= 100)
						{
							// From 100 to 199							
							USART_SEND_BYTE('1');
							PrintZero = 1;
							Number = Number - 100;													
						}
					else
						{
							// From 0 to 99
							if (PrintZero) USART_SEND_BYTE('0');							
						}
				}
		}


	// My number is now less then 100! I'll move it into an "char" so the code from here on is faster
	char QN = Number;

	// Delve right in
	// Tens digit!
	while (USART_DATA_REGISTER_NOT_EMPTY) ;
	if (QN >= 50)
		{
			// QN's from 50 to 99
			if (QN >= 70)
				{
					// QN is from 70 to 99
					if (QN >= 80)
						{
							// QN from 80 to 99
							if (QN >= 90)
								{
									// QN's from 90 to 99
									// I've got the digit!
									USART_SEND_BYTE('9');
									PrintZero = 1;
									QN = QN - 90;
								}
							else
								{
									// QN's from 80 to 89
									// I've got the digit!
									USART_SEND_BYTE('8');
									PrintZero = 1;
									QN = QN - 80;													
								}
						}
					else
						{
							// QN is from 70 to 79
							// I've got the digit!
							USART_SEND_BYTE('7');
							PrintZero = 1;
							QN = QN - 70;													
						}
				}
			else
				{
					// QN is from 50 to 69
					if (QN >= 60)
						{
							// QN is from 60 to 69
							USART_SEND_BYTE('6');
							PrintZero = 1;
							QN = QN - 60;													
						}
					else
						{
							// QN is from 50 to 59
							USART_SEND_BYTE('5');
							PrintZero = 1;
							QN = QN - 50;													
						}
				};
		}
	else
		{
			// QN's from 0 to 49
			if (QN >= 20)
				{
					// QN is from 20 to 49
					if (QN >= 30)
						{
							// QN is from 30 to 49
							if (QN >= 40)
								{
									// QN from 40 to 49
									USART_SEND_BYTE('4');
									PrintZero = 1;
									QN = QN - 40;
								}
							else
								{
									// QN from 30 to 39
									USART_SEND_BYTE('3');
									PrintZero = 1;
									QN = QN - 30;
								}
						}
					else
						{
							// QN is from 20 to 29
							USART_SEND_BYTE('2');
							PrintZero = 1;
							QN = QN - 20;													
						}
				}
			else
				{
					// QN is from 0 to 19
					if (QN >= 10)
						{							
							USART_SEND_BYTE('1');
							PrintZero = 1;
							QN = QN - 10;													
						}
					else
						{
							if (PrintZero) USART_SEND_BYTE('0');							
						}
				}
		}

	// Final digit. Direct print!
	while (USART_DATA_REGISTER_NOT_EMPTY) ;
	if (QN > 10)
		{
			USART_SEND_BYTE('?');
		}
	else
		{
			QN = QN + '0';
			USART_SEND_BYTE(QN);
		}

}

