//*************************************************************************************
//
//  SoR Scope - software to provide Oscilloscope-like with cheap Microcontrollers
//  and free PC software
//
//  Copyright (C) 2009,	Cosmin Prund
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//*************************************************************************************

#include "prepconst.h"
#include "interactiveprompt.h"
#include "fastusart.h"
#include "cmdhandle.h"
#include "scopecounter.h"

int EverSeenAnChar = 0;

// The initial Wait Loop: Send out identification info and loop arround waiting for
// commands
void InteractiveCmdPromptLoop()
{
	EverSeenAnChar = 0;

	while(ScopeOutputMode == 1)
	{
		//SendOutString(MCUID);	SendOutString("\n\r");
		if (USART_IS_RX_BYTE_AVAILABLE)
			{
				volatile char c = USART_READ_BYTE;				
				cmd_handle_char(c);
				Cnt = 0;
				OldCnt = 0;
				EverSeenAnChar = 200;
			}
		else if (EverSeenAnChar > 0)
			{
				if (Cnt != OldCnt)	{
					EverSeenAnChar--;
					OldCnt = Cnt;
				}
			}
		else if ((Cnt >= 0) && (Cnt < 20) && (Cnt != OldCnt)) 
			{
				USART_SEND_BYTE('.');
				OldCnt = Cnt;
			}
		else if (Cnt >= 20)
			{				
				SendOutString("\n\r");
				SendOutString(MCUID);
				SendOutString(", type \"AT?\" to get started:\n\r>");
				Cnt = 0;
			}
	}
}
